#ifndef _TWIN_H_
#define _TWIN_H_
#include <stdlib.h>
#include <stdio.h>
#include <setjmp.h>

#define MAX_VAR 65500

#define FALSE               0
#define TRUE                1

#undef stdin
#define stdin ((FILE *)0)
#undef stdout
#define stdout ((FILE *)1)
#undef stderr
#define stderr ((FILE *)2)

#ifndef	PASCAL

#define FAR	_far
#define NEAR	_near
#define PASCAL	_pascal
#define CDECL	_cdecl

typedef int                 BOOL;
typedef unsigned char       BYTE;
typedef unsigned short      WORD;
typedef unsigned long       DWORD;
typedef unsigned int        UINT;
typedef signed long         LONG;

typedef UINT HWND;
typedef UINT WPARAM;
typedef LONG LPARAM;
typedef LONG LRESULT;

#endif /* !PASCAL */

#ifndef EXPORT
#define EXPORT _export
#endif /* EXPORT */

			    
/*
 * Windows API
 */

#if !defined ( _INC_WINDOWS )
extern void		FAR PASCAL FreeLibrary(unsigned);
extern int		FAR PASCAL GetModuleUsage(unsigned);
extern int		FAR PASCAL GetDeviceCaps(unsigned, int);
extern int		FAR PASCAL ReleaseDC(unsigned, unsigned);
extern long		FAR PASCAL SendMessage(unsigned, unsigned, unsigned, long);
extern int		FAR PASCAL MessageBox(unsigned, char _far *, char _far *, unsigned);
#endif 

/* 
 * function declare for static library.
 */

extern size_t		_far _cdecl hstrlen(const char _huge *strig);
extern char _far * 	_far _cdecl hstrcpy(char _far *string1, const char _huge *string2);
extern char _far *	_far _cdecl hstrcat(char _far *string1, const char _huge *string2);
extern char _far *	_far _cdecl hstrncpy(char _far *string1, const char _huge *string2, size_t count);
extern char _far *	_far _cdecl hstrncat(char _far *string1, const char _huge *string2, size_t count);

extern int		_far _cdecl twprintf(const char _far *, ...);
extern int		_far _cdecl twfprintf(FILE *, const char _far *, ...);
extern int		_far _cdecl twsscanf(char *, const char _far *, ...);
extern int		_far _cdecl twfputs(const char _far *, FILE _far *);
extern char _far *	_far _cdecl twfgets(char _far *, int, FILE _far *);
extern int		_far _cdecl twfgetc(FILE _far *);
extern int		_far _cdecl twfputc(char, FILE _far *);
extern void		_far _cdecl twclearerr(FILE _far *);
extern int		_far _cdecl twfileno(FILE _far *);
extern int		_far _cdecl twferror(FILE _far *);
extern int		_far _cdecl twfflush(FILE _far *);
extern FILE _far *	_far _cdecl twfopen(const char _far *, const char _far *);
extern int		_far _cdecl twfeof(FILE _far *);

/*
 * declare for exported functions in LXLIB.DLL except Xlib's.
 */
extern void		FAR PASCAL EXPORT	FillStreem(const char *);
extern int		FAR PASCAL EXPORT	ReadStreem(char *, int);
extern int		FAR PASCAL EXPORT	WriteStreem(char *, int);
extern int		FAR PASCAL EXPORT	FlushStreem(void);
extern void		FAR PASCAL EXPORT	SetAppInst(unsigned);
extern unsigned		FAR PASCAL EXPORT	GetAppInst(void);
extern void		FAR PASCAL EXPORT	SetXlibInst(unsigned);
extern unsigned		FAR PASCAL EXPORT	GetXlibInst(void);
extern void		FAR PASCAL EXPORT	SetHomeWnd(unsigned);
extern unsigned		FAR PASCAL EXPORT	GetHomeWnd(void);
extern void		FAR PASCAL EXPORT	SetJmpBuf(jmp_buf);
extern jmp_buf *	FAR PASCAL EXPORT	GetJmpBuf(void);
extern unsigned		FAR PASCAL EXPORT	CreateTerminal(unsigned);
extern void		FAR PASCAL EXPORT	DestroyTerm(void);
extern void		FAR PASCAL EXPORT	Twin_CallExit(void);

extern long		FAR PASCAL EXPORT 	WidgetProc(unsigned, unsigned, unsigned, long);
extern long 		FAR PASCAL EXPORT 	TerminalProc(unsigned, unsigned, unsigned, long);
extern long 		FAR PASCAL EXPORT 	TopLevelProc(unsigned, unsigned, unsigned, long);

extern void		FAR PASCAL EXPORT	wputs(const char *, unsigned);

extern unsigned		FAR PASCAL EXPORT	Twin_LoadCursor(char *);
extern void		FAR PASCAL EXPORT	Twin_DestroyCursor(unsigned);
extern unsigned		FAR PASCAL EXPORT	Twin_CreateCursor(int, int, int, int, unsigned, unsigned);
extern void		FAR PASCAL EXPORT	Twin_ClientToScreen(unsigned, int, int, int *, int *);
extern void 		FAR PASCAL EXPORT	Twin_Scroll(unsigned, int, int, unsigned, unsigned, int, int);
extern unsigned		 FAR PASCAL		Twin_LoadIcon(char *);

#endif /* _TWIN_H_ */
