/*
 * twinint.h --
 *
 * Copyright (c) 1994 Software Research Associates, Inc.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Software Research Associates not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  Software Research
 * Associates makes no representations about the suitability of this software
 * for any purpose.  It is provided "as is" without express or implied
 * warranty.
 */

#include <windows.h>
#include <X11/xlib.h>
#include <X11/xutil.h>
#include <twin.h>

#define HDC_OFFSET		0	       
#define HCCS_OFFSET 		2
#define HPCS_OFFSET		4
#define XSWA_OFFSET 		6
#define XWCH_OFFSET 		8
#define CONTEXT_OFFSET		10
#define HACS_OFFSET 		12

#define IDM_CURSORCHANGED 1
#define IDM_CHANGEICON 2

#define INPUTNOTIFY	WM_USER
#define EXITNOTIFY	WM_USER+1
#define TIMERNOTIFY	WM_TIMER

#define CREATENOTIFY	WM_USER+10
#define FOCUSIN		WM_USER+11
#define FOCUSOUT	WM_USER+12
#define CONFIGURENOTIFY	WM_USER+13
#define MAPNOTIFY	WM_USER+14
#define UNMAPNOTIFY	WM_USER+15
#define SELECTIONCLEAR	WM_USER+16
#define CLIENTMESSAGE	WM_USER+17
#define ACTIVATEAPP	WM_USER+18
#define EXPOSE2		WM_USER+19
#define DESTROYNOTIFY	WM_QUIT
#define BUTTONPRESS	WM_LBUTTONDOWN
#define BUTTONRELEASE	WM_LBUTTONUP
#define MOTIONNOTIFY	WM_MOUSEMOVE
#define KEYPRESS	WM_KEYDOWN
#define KEYRELEASE	WM_KEYUP
#define EXPOSE		WM_PAINT

#define ERROREVENT	WM_USER+9
#define WM_NO_BUFFERED  WM_USER+20
#define PROPERTYNOTIFY	WM_USER+21
#define ON  1
#define OFF 0

extern int cIdTopLevel;
extern HWND hDeskTop;

extern int fAutoGrab;
extern int fPtGrab;
extern HWND hPtGrabWnd;
extern int fKbGrab;
extern HWND hKbGrabWnd;

extern int cxChar, cyChar;	/* size of system font. */
extern int cxFrame, cyFrame;	/* width of frame. */
extern int cyCaption;		/* width of Title bar. */
extern int cxVScroll;		/* width of vertical scroll bar. */
extern int cxDiff, cyDiff;	/* difference between outline of window 
			   and client area. */
extern HCURSOR hDefaultCursor;
extern FARPROC ClearProps;

extern int nColorres;
extern int nBitsPixel;

extern int		NEAR PASCAL		AdjustWidth(int width, int flag);
extern int		NEAR PASCAL		AdjustHeight(int height, int flag);
extern int		NEAR PASCAL		ReAdjustWidth(int width, int flag);
extern int		NEAR PASCAL		ReAdjustHeight(int height, int flag);
extern int		NEAR PASCAL		AdjustX(int x, int flag);
extern int		NEAR PASCAL		AdjustY(int y, int flag);
extern int		NEAR PASCAL		ReAdjustX(int x, int flag);
extern int		NEAR PASCAL		ReAdjustY(int y, int flag);

extern unsigned		NEAR PASCAL		GetDrawableDC(unsigned);
extern void		NEAR PASCAL		ReleaseDrawableDC(unsigned, unsigned);

extern unsigned char	NEAR PASCAL		_SetWindowChanges(HWND, unsigned long, XWindowChanges *);
extern unsigned char	NEAR PASCAL		_SetWindowAttributes(HWND, unsigned long, XSetWindowAttributes *);

extern void		NEAR PASCAL		WaitInput(void);

extern void		NEAR PASCAL		PostError(BYTE, UINT);
extern int		NEAR PASCAL		msg3event(Display *, MSG *, XEvent *);

extern void		NEAR PASCAL		SetClearProps(HINSTANCE);


extern	BOOL 		CALLBACK EXPORT		SendActivate(HWND, LPARAM);
extern	BOOL 		CALLBACK EXPORT		PostPaint(HWND, LPARAM);
extern	BOOL 		CALLBACK EXPORT		DeleteProperty(HWND, LPCSTR, HANDLE);
extern	LRESULT 	CALLBACK EXPORT		DeliverEnterLeave(int, WPARAM, LPARAM);

extern void 		NEAR PASCAL		SetDefaultCursor(HCURSOR);
extern HCURSOR 		NEAR PASCAL		GetDefaultCursor(void);
extern HCURSOR 		NEAR PASCAL		FindCursor(HWND);

extern void		FAR PASCAL EXPORT	SetHookDeliverEL(unsigned long);
extern HHOOK		FAR PASCAL EXPORT	GetHookDeliverEL(void);
extern void 		FAR PASCAL EXPORT 	RegisterWidgetClass(unsigned);
extern void 		FAR PASCAL EXPORT 	RegisterTerminalClass(unsigned);
extern void 		FAR PASCAL EXPORT	RegisterTopLevelClass(unsigned);
