/* 
 * twhstr.c
 *
 * Copyright (c) 1994 Software Research Associates, Inc.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Software Research Associates not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  Software Research
 * Associates makes no representations about the suitability of this software
 * for any purpose.  It is provided "as is" without express or implied
 * warranty.
 */

#include "twin.h"

size_t _far _cdecl
hstrlen(const char _huge *s)
{
    const char _huge *c;

    for (c = s; *c != '\0'; c++)
    	;

    return (size_t) (c - s);
}

char _far * _far _cdecl 
hstrcpy(char _far *s1, const char _huge *s2)
{
    char _far *c = s1;

    while ((*c++ = *s2++) != '\0')
    	;

    return s1;
}

char _far * _far _cdecl 
hstrcat(char _far *s1, const char _huge *s2)
{
    char _far *c;

    for (c = s1; *c != '\0'; c++)
    	;
    while ((*c++ = *s2++) != '\0')
    	;

    return s1;
}

char _far * _far _cdecl 
hstrncpy(char _far *s1, const char _huge *s2, size_t n)
{
    char _far *c;

    for (c = s1; 0 < n && *s2 != '\0'; n--)
    	*c++ = *s2++;
    for (; 0 < n; n--)
    	*c++ = '\0';

    return s1;
}

char _far * _far _cdecl 
hstrncat(char _far *s1, const char _huge *s2, size_t n)
{
    char _far *c;

    for (c = s1; *c != '\0'; c++)
    	;
    for (; 0 < n && *s2 != '\0'; n--)
    	*c++ = *s2++;
    *c = '\0';

    return s1;
}