/*
 * tklib.c --
 *
 * Copyright (c) 1994 Software Research Associates, Inc.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Software Research Associates not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  Software Research
 * Associates makes no representations about the suitability of this software
 * for any purpose.  It is provided "as is" without express or implied
 * warranty.
 */

#include <windows.h>
#include <string.h>
#include <stdlib.h>
#ifdef KANJI
#include <tcl.h>

#ifdef _WINDOWS
Tcl_KanjiEncodeProc Tcl_KanjiEncode = { Tcl_EncodeKANJI,
					Tcl_EncodeKANJI,
					Tcl_EncodeKANJI,
					Tcl_EncodeKANJI };
Tcl_KanjiDecodeProc Tcl_KanjiDecode = { Tcl_DecodeKANJI,
					Tcl_DecodeKANJI,
					Tcl_DecodeKANJI,
					Tcl_DecodeKANJI };
#else
Tcl_KanjiEncodeProc Tcl_KanjiEncode = { Tcl_EncodeJIS,
					Tcl_EncodeSJIS,
					Tcl_EncodeEUC,
					Tcl_EncodeANY };
Tcl_KanjiDecodeProc Tcl_KanjiDecode = { Tcl_DecodeJIS,
					Tcl_DecodeSJIS,
					Tcl_DecodeEUC,
					Tcl_DecodeANY };
#endif
#endif 

int minTrackWidth;
int pure = 1;

int 
__far __pascal 
LibMain(HANDLE hInstance, WORD wDataSeg,
			WORD wHeapSize, LPSTR lpCmdLine)
{
    int cyCaption, cxBorder;
    char *p;

    cyCaption = GetSystemMetrics(SM_CYCAPTION);
    cxBorder = GetSystemMetrics(SM_CXBORDER);
    minTrackWidth = cyCaption * 3 - cxBorder * 6;
    if ((p = getenv("PURE")) != NULL) {
	if (strcmp(p, "OFF") == 0) {
	    pure = 0;
	}
    }

    if (wHeapSize > 0)
	UnlockData(0);

    return 1;
}

int  __far __pascal
_WEP(i)
int i;
{
    return 1;
}
