/*
 * callback.c --
 *
 * Copyright (c) 1994,1995 Software Research Associates, Inc.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Software Research Associates not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  Software Research
 * Associates makes no representations about the suitability of this software
 * for any purpose.  It is provided "as is" without express or implied
 * warranty.
 */
 
#include <twinint.h>

static HHOOK hDeliverEL;

static void	NEAR	CainEnterNotify(HWND, POINT, int);
static void	NEAR	CainLeaveNotify(HWND, POINT, int);

BOOL CALLBACK 
DeleteProperty(HWND hwnd, LPCSTR lpsz, HANDLE hData)	
{
    RemoveProp(hwnd, lpsz);
    GlobalFree(hData);
    return 1;
}

HHOOK FAR PASCAL
GetHookDeliverEL(void)
{
   return hDeliverEL;
}
 
LRESULT CALLBACK 
DeliverEnterLeave(int code, WPARAM wParam, LPARAM lParam)
{
    MOUSEHOOKSTRUCT * lpmhs = (MOUSEHOOKSTRUCT *)lParam;
    POINT pt = lpmhs->pt;
    HWND hcur = lpmhs->hwnd;
    extern HTASK mytask;
    static HWND hprev = 0;
    static POINT ptPrev = {0, 0};

    if (code < 0 || (wParam != WM_MOUSEMOVE && wParam != WM_NCMOUSEMOVE) ) 
    	goto nexthook;

    if (hprev == hcur) 
   	goto nexthook;

    if (GetWindowTask(hprev) == mytask && hprev != hDeskTop) {
    	if (GetWindowTask(hcur) != mytask || hcur == hDeskTop) {			
	    CainLeaveNotify(hprev, ptPrev, NotifyAncestor);
	} else {						
	    HWND hwnd1, hwnd2;

	    if (hprev == hcur) 
	   	goto nexthook;
   	   
	    for (hwnd1 = hcur; hwnd1 != HWND_DESKTOP; hwnd1 = GetParent(hwnd1)) {
	    	if  (hwnd1 == hprev) {
		    CainLeaveNotify(hprev, ptPrev, NotifyInferior);
		    CainEnterNotify(hcur, pt, NotifyAncestor);
		    goto nexthook;
		}
	    }
	    for (hwnd2 = hprev; hwnd2 != HWND_DESKTOP; hwnd2 = GetParent(hwnd2)) {
	    	if (hwnd2 == hcur) {
		    CainLeaveNotify(hprev, ptPrev, NotifyAncestor);
		    CainEnterNotify(hcur, pt, NotifyInferior);
		    goto nexthook;
		}
	    }
	    CainEnterNotify(hcur, pt, NotifyNonlinear);
	    CainLeaveNotify(hprev, ptPrev, NotifyNonlinear);
	}
    } else {
    	if (GetWindowTask(hcur) == mytask) { 	    
	    CainEnterNotify(hcur, pt, NotifyAncestor);
	}
    }

nexthook:
    hprev = hcur;
    ptPrev.x = pt.x;
    ptPrev.y = pt.y;
    if (fPtGrab && (GetWindowTask(hcur) != mytask || hcur == hDeskTop) ) {
	ScreenToClient(hPtGrabWnd, &pt);
	PostMessage(hPtGrabWnd, wParam, 0, (pt.y << 16 | pt.x));
        return 1;
    }

    return CallNextHookEx(hDeliverEL, code, wParam, lParam);
}

void FAR PASCAL
SetHookDeliverEL(HHOOK handle)
{
   hDeliverEL = handle;
}
 
static void NEAR
CainEnterNotify(HWND hwnd, POINT pt, int detaile)
{
    XEvent e;

    ScreenToClient(hwnd, &pt);
    e.type = EnterNotify;
    e.xany.window = (Window) hwnd;
    e.xcrossing.x = pt.x;
    e.xcrossing.y = pt.y;
    e.xcrossing.detail = detaile;
    e.xcrossing.mode = 0;	
    e.xcrossing.focus = 0;	
    e.xcrossing.state = 0;
    XPutBackEvent(XOpenDisplay(NULL), &e);
}

static void NEAR
CainLeaveNotify(HWND hwnd, POINT pt, int detail)
{
    XEvent e;

    ScreenToClient(hwnd, &pt);
    e.type = LeaveNotify;
    e.xany.window = (Window) hwnd;
    e.xcrossing.x = pt.x;
    e.xcrossing.y = pt.y;
    e.xcrossing.detail = detail;
    e.xcrossing.mode = 0;
    e.xcrossing.focus = 0;
    e.xcrossing.state = 0;
    XPutBackEvent(XOpenDisplay(NULL), &e);
}
