/*
 * lxlib.c --
 *
 * Copyright (c) 1994,1995 Software Research Associates, Inc.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Software Research Associates not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  Software Research
 * Associates makes no representations about the suitability of this software
 * for any purpose.  It is provided "as is" without express or implied
 * warranty.
 */
 
#include "twinint.h"

HWND hDeskTop;
HINSTANCE hLibInst = NULL;

int cxChar, cyChar;	/* size of system font. */
int cxFrame, cyFrame;	/* width of frame. */
int cyCaption;		/* width of Title bar. */
int cxVScroll;		/* width of vertical scroll bar. */
int cxDiff, cyDiff;	/* difference between outline of window 
			   and client area. */

HCURSOR hDefaultCursor;
FARPROC ClearProps;

int nColorres;
int nBitsPixel;

extern int 	FAR PASCAL		DefaultErrorHandler(Display *, XErrorEvent *);

XErrorHandler errorHandler = DefaultErrorHandler;

int FAR PASCAL
LibMain(HINSTANCE hInstance, WORD wDataSeg, WORD wHeapSize, LPSTR lpCmdLine)
{
    HDC hdc;
    TEXTMETRIC tm;
    HHOOK hHook;

    if (hLibInst ==  NULL) {
	RegisterWidgetClass(hInstance);	
	RegisterTopLevelClass(hInstance);
	RegisterTerminalClass(hInstance);
	hLibInst = hInstance;
    } 
    hDeskTop = GetDesktopWindow();
    ClearProps = MakeProcInstance(DeleteProperty, hInstance);
    hDefaultCursor =  LoadCursor(0, IDC_ARROW);

    hdc = GetDC((HWND) 0);

    SelectObject(hdc, GetStockObject(SYSTEM_FIXED_FONT));
    GetTextMetrics(hdc, &tm);

    nColorres = GetDeviceCaps(hdc, COLORRES);
    nBitsPixel = GetDeviceCaps(hdc, BITSPIXEL);        

    ReleaseDC((HWND) 0, hdc);

    cxChar = tm.tmAveCharWidth;
    cyChar = tm.tmHeight;
    cxFrame = GetSystemMetrics(SM_CXFRAME);
    cyFrame = GetSystemMetrics(SM_CYFRAME);
    cyCaption = GetSystemMetrics(SM_CYCAPTION);
    cxVScroll = GetSystemMetrics(SM_CXVSCROLL);
    cxDiff = cxFrame * 2;
    cyDiff = cyCaption + (cyFrame * 2);

    hHook = SetWindowsHookEx(WH_MOUSE, 
    	    (HOOKPROC)GetProcAddress(hInstance, (LPCSTR)"DeliverEnterLeave"), 
    	    hInstance, (HTASK)NULL); 

    SetHookDeliverEL(hHook);
    if (wHeapSize > 0) {
	UnlockData(0);
    }

    return 1;
}

int FAR PASCAL 
WEP(int i)
{
    UnhookWindowsHookEx(GetHookDeliverEL());
    UnregisterClass("Terminal", hLibInst);
    UnregisterClass("TopLevel", hLibInst);
    UnregisterClass("Widget", hLibInst);
    return i;
}
