/*
 * msg2evt.c -- 
 *
 * Copyright (c) 1994,1995 Software Research Associates, Inc.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Software Research Associates not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  Software Research
 * Associates makes no representations about the suitability of this software
 * for any purpose.  It is provided "as is" without express or implied
 * warranty.
 */
 
#include "twinint.h"
#include <stdlib.h>
#ifdef KANJI
#include <mbctype.h>
#endif /* KANJI */

extern XErrorHandler errorHandler;                          
int fMuseButton	= 2;

static short	GetState(int flag);

int NEAR PASCAL					
msg3event(lpDisp, lpMsg, lpXEvent)
Display FAR * lpDisp;
MSG FAR * lpMsg;
XEvent FAR * lpXEvent;
{
    POINT pt;	
    DWORD value;
    WINDOWPOS FAR * lpwp;
    PAINTSTRUCT ps;
    HDC hdc;
    static DWORD cserial = 0;
    static int fMb = 0;

    lpXEvent->xany.serial = cserial++;
    lpXEvent->xany.send_event = False;
    lpXEvent->xany.display = lpDisp;
    lpXEvent->xany.window = lpMsg->hwnd;
    switch(lpMsg->message) {
    case INPUTNOTIFY :
	lpXEvent->type = InputNotify;
	lpXEvent->xany.window = (Window) lpMsg->wParam;
	break;
		
    case TIMERNOTIFY :
	lpXEvent->type = TimerNotify; 
	break;

    case EXITNOTIFY :
	lpXEvent->type = ExitNotify; 
	break;
     
    case ACTIVATEAPP:
    	lpXEvent->type = ActivateApp;
	break;

    case WM_CHAR: 
	lpXEvent->type = KeyPress;
#ifdef KANJI    
	if(fMb == 0 && _ismbblead((unsigned short)lpMsg->wParam)) {
    		lpXEvent->xkey.keycode = 0x0100;
		fMb = 1;
	} else if(fMb == 1 && _ismbbtrail((unsigned short)lpMsg->wParam)) {
    		lpXEvent->xkey.keycode = 0x0200;
		fMb = 0;
	} else {
    		lpXEvent->xkey.keycode = 0x0400;
		fMb = 0;
	}       
#else 	
	lpXEvent->xkey.keycode = 0x0400;
#endif /* KANJI */
	goto common_keyevent;

    case WM_KEYDOWN :
    case WM_SYSKEYDOWN:
	lpXEvent->type = KeyPress;
	lpXEvent->xkey.keycode = 0;
	goto common_keyevent;

    case WM_KEYUP :
    case WM_SYSKEYUP:
	lpXEvent->type = KeyRelease;
	lpXEvent->xkey.keycode = 0;

common_keyevent:
	lpXEvent->xkey.root = HWND_DESKTOP; 	
	lpXEvent->xkey.subwindow = lpMsg->hwnd;		  
	lpXEvent->xkey.time = lpMsg->time;
	value = GetMessagePos();
	pt = MAKEPOINT(value);
	lpXEvent->xkey.x_root = pt.x;
	lpXEvent->xkey.y_root = pt.y;
	ScreenToClient(lpMsg->hwnd, &pt);
	lpXEvent->xkey.x = pt.x;
	lpXEvent->xkey.y = pt.y; 
	lpXEvent->xkey.state = GetState(0);
	lpXEvent->xkey.keycode |= lpMsg->wParam;
	lpXEvent->xkey.same_screen = True;
	break;

    case WM_LBUTTONDBLCLK:
    case WM_MBUTTONDBLCLK:
    case WM_RBUTTONDBLCLK:
    case WM_LBUTTONDOWN :
    case WM_MBUTTONDOWN :
    case WM_RBUTTONDOWN :
	lpXEvent->type = ButtonPress;		    
	if (GetCapture() == NULL) {
//            XGrabPointer(NULL, lpMsg->hwnd, 0, 0, 0, 0, 0, 0, 0);
	    SetCapture(lpMsg->hwnd);
	    fAutoGrab = ON;
	} 
	goto common_buttonevent;

    case WM_LBUTTONUP :
    case WM_MBUTTONUP :
    case WM_RBUTTONUP :
	lpXEvent->type = ButtonRelease;
	if (GetCapture() == lpMsg->hwnd && fAutoGrab != 0) {
//	if (hPtGrabWnd == lpMsg->hwnd && fAutoGrab != 0) {
	    ReleaseCapture();
//	    XUngrabPointer(NULL, 0);
	    fAutoGrab = OFF;
	}
common_buttonevent:
	lpXEvent->xbutton.root = HWND_DESKTOP;
	lpXEvent->xbutton.subwindow = lpMsg->hwnd;
	lpXEvent->xbutton.time = lpMsg->time;
	lpXEvent->xbutton.x = pt.x = LOWORD(lpMsg->lParam);
	lpXEvent->xbutton.y = pt.y = HIWORD(lpMsg->lParam);
	ClientToScreen(lpMsg->hwnd, &pt);
	lpXEvent->xbutton.x_root = pt.x;
	lpXEvent->xbutton.y_root = pt.y;
	lpXEvent->xbutton.state = GetState(lpMsg->message);
	switch (lpMsg->message) {
	case WM_LBUTTONUP :
	case WM_LBUTTONDOWN:
	case WM_LBUTTONDBLCLK:
	    lpXEvent->xbutton.button = Button1; 
	    break;	
	case WM_MBUTTONUP :
	case WM_MBUTTONDOWN:
	case WM_MBUTTONDBLCLK:
	    lpXEvent->xbutton.button = Button2; 
	    break;	
	case WM_RBUTTONUP :
	case WM_RBUTTONDOWN:
	case WM_RBUTTONDBLCLK:
	    if (fMuseButton == 2) {
		if (lpXEvent->xbutton.state & Mod2Mask) {
		    lpXEvent->xbutton.button = Button3;
		    lpXEvent->xbutton.state &= ~Mod2Mask;
		} else {
		    lpXEvent->xbutton.button = Button2; 
		}
    	    } else {
		lpXEvent->xbutton.button = Button3;
	    }
	    break;	
	}
	lpXEvent->xbutton.same_screen = True;
	lpXEvent->xbutton.state &= ~Mod1Mask;
	break;

    case WM_MOUSEMOVE :   			/* MotionNotify */
	lpXEvent->type = MotionNotify;
	lpXEvent->xmotion.root = HWND_DESKTOP;	  
	lpXEvent->xmotion.subwindow = lpMsg->hwnd;
	lpXEvent->xmotion.time = lpMsg->time;
	lpXEvent->xmotion.x = pt.x = LOWORD(lpMsg->lParam);
	lpXEvent->xmotion.y = pt.y = HIWORD(lpMsg->lParam);
	ClientToScreen(lpMsg->hwnd, &pt);
	lpXEvent->xmotion.x_root = pt.x;
	lpXEvent->xmotion.y_root = pt.y;
	lpXEvent->xmotion.state = GetState(0);
	lpXEvent->xmotion.is_hint = NotifyNormal;
	lpXEvent->xmotion.same_screen = True;
	break;

    /* XCrossingEvent */

    /* XFocusChangeEvent */
    case FOCUSIN :			/* FocusIn Event */
	lpXEvent->type = FocusIn;
	lpXEvent->xfocus.mode = 
		fKbGrab ? NotifyWhileGrabbed : NotifyNormal; 
	lpXEvent->xfocus.detail = NotifyVirtual;
	break;

    case FOCUSOUT :			/* FocusOut Event */
	lpXEvent->type = FocusOut;
	lpXEvent->xfocus.mode =
		fKbGrab ? NotifyWhileGrabbed : NotifyNormal; 
	lpXEvent->xfocus.detail = NotifyVirtual;
	break;

    /* XKeymapEvent */

    /* XExposeEvent */
    case EXPOSE :				/* Expose Event */
    case EXPOSE2:
	lpXEvent->type = Expose;
	lpXEvent->xexpose.count = 0;
	if (lpMsg->lParam) {
	    RECT FAR * lprc = (RECT FAR *) lpMsg->lParam;
	    lpXEvent->xexpose.x = lprc->left;
	    lpXEvent->xexpose.y = lprc->top;
	    lpXEvent->xexpose.width = lprc->right - lprc->left;
	    lpXEvent->xexpose.height = lprc->bottom - lprc->top;
	    free(lprc);
	    break;
	}
        hdc = BeginPaint(lpMsg->hwnd, &ps);
	lpXEvent->xexpose.x = ps.rcPaint.left;
	lpXEvent->xexpose.y = ps.rcPaint.top;
	lpXEvent->xexpose.width = ps.rcPaint.right - ps.rcPaint.left;
	lpXEvent->xexpose.height = ps.rcPaint.bottom - ps.rcPaint.top;
	EndPaint(lpMsg->hwnd, &ps);
	break;

    /* XGraphicsExposeEvent, XNoExposeEvent */
    /* XVisibilityEvent */

    /* XCreateWindowEvent */
    case CREATENOTIFY :
	lpXEvent->type = CreateNotify;
	lpXEvent->xcreatewindow.x = ((CREATESTRUCT FAR *)lpMsg->lParam)->x;
	lpXEvent->xcreatewindow.y = ((CREATESTRUCT FAR *)lpMsg->lParam)->y;
	lpXEvent->xcreatewindow.width = 
		((CREATESTRUCT FAR *)lpMsg->lParam)->cx;
	lpXEvent->xcreatewindow.height = 
		((CREATESTRUCT FAR *)lpMsg->lParam)->cy;
	lpXEvent->xcreatewindow.border_width = 1;
	lpXEvent->xcreatewindow.override_redirect = False;
	break;

    /* XDestroyWindowEvent */
    case DESTROYNOTIFY :
	lpXEvent->type = DestroyNotify;
	lpXEvent->xdestroywindow.event = lpMsg->wParam;
	lpXEvent->xdestroywindow.window = lpMsg->wParam; 
        if (fPtGrab && hPtGrabWnd == lpMsg->wParam) {
	    fPtGrab = 0;
	}
	break;

#if 0        
    case FOCUSIN :			/* FocusIn Event */
	lpXEvent->type = FocusIn;
	lpXEvent->xfocus.mode = NotifyNormal; 
	lpXEvent->xfocus.window = (Window) lpMsg->hwnd; break;

    case FOCUSOUT :			/* FocusOut Event */
	lpXEvent->type = FocusIn;
	lpXEvent->xfocus.mode = NotifyNormal;
	lpXEvent->xfocus.window = (Window) lpMsg->hwnd; break;
#endif

    case  MAPNOTIFY:			/* MapNotify, UnmapNotify Event */
	lpXEvent->type = MapNotify;
	lpXEvent->xmap.event = lpMsg->hwnd;		
	lpXEvent->xmap.window = lpMsg->hwnd;		
	lpXEvent->xmap.override_redirect= False;
	break;

    case UNMAPNOTIFY:
	lpXEvent->type = UnmapNotify;
	lpXEvent->xunmap.event = lpMsg->hwnd;		
	lpXEvent->xunmap.window = lpMsg->hwnd;		
	lpXEvent->xunmap.from_configure= False;
	break;

    /* XMapRequestEvent */
    /* XReparentEvent */

    /* XConfigureEvent */
    case CONFIGURENOTIFY : 		/* ConfigureNotify, CirculateNotify Event */
	lpwp = (WINDOWPOS FAR *) GlobalLock((HGLOBAL) lpMsg->wParam);
	lpXEvent->type = ConfigureNotify;
	lpXEvent->xconfigure.event = lpMsg->hwnd; 
	lpXEvent->xconfigure.window = lpMsg->hwnd; 
	lpXEvent->xconfigure.x = lpwp->x;
	lpXEvent->xconfigure.y = lpwp->y;
	lpXEvent->xconfigure.width = lpwp->cx;
	lpXEvent->xconfigure.height = lpwp->cy;
	lpXEvent->xconfigure.border_width = 1;	
	lpXEvent->xconfigure.above = lpwp->hwndInsertAfter;
	lpXEvent->xconfigure.override_redirect = False;
	if (IsIconic(lpwp->hwnd))
	    value = 1;
	else
	    value = 0;
	GlobalUnlock((HGLOBAL) lpMsg->wParam);
	GlobalFree((HGLOBAL) lpMsg->wParam);
	if (value) return 0;
	break;

    case SELECTIONCLEAR:
    	lpXEvent->type = SelectionClear;
	lpXEvent->xselectionclear.window = (Window) lpMsg->hwnd;
	lpXEvent->xselectionclear.selection = 0;
	lpXEvent->xselectionclear.serial = 1;
	break;

    case CLIENTMESSAGE:
    	lpXEvent->type = ClientMessage;
        lpXEvent->xclient.data.l[0] = XInternAtom(NULL, "WM_DELETE_WINDOW", False);
	lpXEvent->xany.window = (Window) lpMsg->wParam;
	break;

    case PROPERTYNOTIFY:
    	lpXEvent->xproperty.atom = (Atom) lpMsg->wParam;
	lpXEvent->xproperty.time = lpMsg->time;
        lpXEvent->xproperty.state = (int) lpMsg->lParam;
	break;

    case ERROREVENT:
    	if (lpMsg->hwnd == GetHomeWnd()) {
	    XErrorEvent	ee;
	    ee.resourceid = (XID) lpMsg->lParam;
	    ee.error_code = (unsigned char) lpMsg->wParam;
	    (*errorHandler)(NULL, &ee);
	}
	return 0;

    default :
	goto waste_basket;
    }
    return 1;

waste_basket:
    return 0;
}

static short 
GetState(int flag)
{
    short state = 0;

    if (GetKeyState(VK_SHIFT) & 0x8000) state |= ShiftMask;
    if (GetKeyState(VK_CAPITAL) & 0x0001) state |= LockMask; 
    if (GetKeyState(VK_CONTROL) & 0x8000) state |= ControlMask; 
    if (GetKeyState(VK_NUMLOCK) & 0x0001) state |= Mod1Mask; 
    if (GetKeyState(VK_MENU) & 0x8000) {
        state |= Mod2Mask; 
    }
    if (GetKeyState(VK_SCROLL) & 0x0001)  state |= Mod3Mask; 

    switch (flag) {
    case WM_LBUTTONUP :
	state |= Button1Mask;
	break;	
    case WM_MBUTTONUP :
	state |= Button2Mask;
	break;	
    case WM_RBUTTONUP :
	if (fMuseButton == 2) {
	    state |= (state & Mod2Mask) ? Button3Mask : Button2Mask;
	} else {
	    state |= Button3Mask;
	}
	break;	
    }

    if (flag) 
	return state;

    if (GetKeyState(VK_LBUTTON) & 0x8000) state |= Button1Mask;
    if (GetKeyState(VK_MBUTTON) & 0x8000) state |= Button2Mask; 
    if (fMuseButton == 2) {
	if (GetKeyState(VK_RBUTTON) & 0x8000) {
	    if (state & Mod2Mask) {
	    	state |= Button3Mask;
		state &= ~Mod2Mask;
	    } else {
	    	state |= Button2Mask;
	    }
	}
    } else {
	if (GetKeyState(VK_RBUTTON) & 0x8000) state |= Button3Mask;
    }
    return  state;
}

