/*
 * twutil.c --
 *
 * Copyright (c) 1994 Software Research Associates, Inc.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Software Research Associates not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  Software Research
 * Associates makes no representations about the suitability of this software
 * for any purpose.  It is provided "as is" without express or implied
 * warranty.
 */

#include <windows.h>
#include <twin.h>
#include <string.h>

extern HINSTANCE hLibInst;

HCURSOR FAR PASCAL
Twin_LoadCursor(char *name)
{
    return LoadCursor(hLibInst, name);
}

void FAR PASCAL
Twin_DestroyCursor(HCURSOR hcur)
{
    DestroyCursor(hcur);
}

HCURSOR FAR PASCAL
Twin_CreateCursor(int nWidth, int nHeight, int xHotSpot, int yHotSpot, HBITMAP hsrc, HBITMAP hmask)
{
    char ANDplane[128];
    char XORplane[128];

    GetBitmapBits(hsrc, 128, ANDplane);
    GetBitmapBits(hmask, 128, XORplane);
    if (hsrc == hmask) {
        memset(XORplane, 0, 128);
    }
    return CreateCursor(GetAppInst(), xHotSpot, yHotSpot, nWidth, nHeight, ANDplane, XORplane);
}

void FAR PASCAL
Twin_ClientToScreen(HWND w, int cx, int cy, int *sx, int *sy)
{
    POINT pt;

    pt.x = cx;
    pt.y = cy;
    ClientToScreen(w, &pt);
    *sx = pt.x;
    *sy = pt.y;
}