/*
 * xallocsh.c --
 *
 * Copyright (c) 1994,1995 Software Research Associates, Inc.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Software Research Associates not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  Software Research
 * Associates makes no representations about the suitability of this software
 * for any purpose.  It is provided "as is" without express or implied
 * warranty.
 */
 
#include "twinint.h"
#include <x11/xutil.h>
#include <string.h>

/*
 * XAllocSizeHints --
 *
 */

XSizeHints FAR * FAR PASCAL
XAllocSizeHints(void)
{
    return (XSizeHints FAR *) malloc(sizeof(XSizeHints));
}

/*
 * XSetWMNormalHints --
 *
 */

void FAR PASCAL
XSetWMNormalHints(Display FAR * dummy, HWND hWnd, XSizeHints FAR * lpSHints)
{
    HGLOBAL hGlobal;
    XSizeHints FAR * lpshints;

    if ((hGlobal = GetProp(hWnd, "XA_WM_NORMAL_HINTS")) == NULL) {
    	hGlobal = GlobalAlloc(GHND, sizeof(XSizeHints));
    }
    if ((lpshints = (XSizeHints FAR *) GlobalLock(hGlobal)) == NULL) {
	PostError(BadAlloc, hWnd);	
	return;
    }
    *lpshints = *lpSHints;
    GlobalUnlock(hGlobal);
    SetProp(hWnd, "XA_WM_NORMAL_HINTS", hGlobal);
}

/*
 * XSetWMHints --
 *
 */

void FAR PASCAL
XSetWMHints(Display FAR * dummy, HWND hWnd, XWMHints FAR *lpWMHints)
{
    HGLOBAL hGlobal;
    XWMHints FAR * lphints;

    if ((hGlobal = GetProp(hWnd, "XA_WM_HINTS")) == NULL) {
    	hGlobal = GlobalAlloc(GHND, sizeof(XWMHints));
    }
    if ((lphints = (XWMHints *) GlobalLock(hGlobal)) == NULL) {
	PostError(BadAlloc, hWnd);	
	return;
    }
    *lphints = *lpWMHints;
    GlobalUnlock(hGlobal);
    SetProp(hWnd, "XA_WM_HINTS", hGlobal);
    if (lphints->flags & IconPixmapHint) {
    	SendMessage(hWnd, WM_COMMAND, IDM_CHANGEICON, MAKELONG(0, lphints->icon_pixmap));
    }
}

/*
 * XFree --
 *
 */
 	
void FAR PASCAL
XFree(char * ptr)
{
    free((void *)ptr);
}