/*
 * xconfwin.c --
 *
 * Copyright (c) 1994,1995 Software Research Associates, Inc.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Software Research Associates not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  Software Research
 * Associates makes no representations about the suitability of this software
 * for any purpose.  It is provided "as is" without express or implied
 * warranty.
 */
 
#include "twinint.h"

/*
 * XConfigureWindow --
 *
 */

void FAR PASCAL
XConfigureWindow(dummy, hwnd, mask, lpXWChanges)
Display FAR * dummy;
HWND hwnd;
unsigned mask;
XWindowChanges FAR * lpXWChanges;
{  
    BYTE result;
    
    result = _SetWindowChanges(hwnd, mask, lpXWChanges); 
    if (result != Success) 
    	PostError(result, hwnd);
}

/*
 * XMoveWindow --
 *
 */

void FAR PASCAL
XMoveWindow(Display FAR * dummy, HWND hwnd, int x, int y)
{
    XWindowChanges XWChanges;
    BYTE result;
     
    XWChanges.x = x;
    XWChanges.y = y;
    result = _SetWindowChanges(hwnd, CWX|CWY,  &XWChanges);
    if (result != Success) 
    	PostError(result, hwnd);
}

void FAR PASCAL
XResizeWindow(Display FAR * dummy, HWND hwnd, unsigned width, unsigned height)
{
    XWindowChanges XWChanges;
    BYTE result;

    XWChanges.width = width;
    XWChanges.height = height;
    result = _SetWindowChanges(hwnd, CWWidth|CWHeight, &XWChanges);
    if (result != Success) 
    	PostError(result, hwnd);
}

void FAR PASCAL
XMoveResizeWindow(Display FAR * dummy, HWND hwnd, int x, int y, 
	unsigned width, unsigned height)
{
    XWindowChanges XWChanges;
    BYTE result;

    XWChanges.x = x;
    XWChanges.y = y;
    XWChanges.width = width;
    XWChanges.height = height;
    result = _SetWindowChanges(hwnd, CWX|CWY|CWWidth|CWHeight, &XWChanges);
    if (result != Success) 
    	PostError(result, hwnd);
}

void FAR PASCAL 
XSetWindowBorderWidth(Display FAR * dummy, HWND hwnd, unsigned int width)
{
    XWindowChanges XWChanges;
    BYTE result;

    XWChanges.border_width = width;
    result = _SetWindowChanges(hwnd, CWBorderWidth, &XWChanges);
    if (result != Success) 
    	PostError(result, hwnd);
}

void FAR PASCAL
XRaiseWindow(Display FAR * dummy, HWND hwnd)
{
    XWindowChanges XWChanges;
    BYTE result;

    XWChanges.sibling = None;
    XWChanges.stack_mode = Above;
    result = _SetWindowChanges(hwnd, CWSibling|CWStackMode, &XWChanges);
    if (result != Success) 
    	PostError(result, hwnd);
}