/*
 * xdefcur.c --
 *
 * Copyright (c) 1994,1995 Software Research Associates, Inc.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Software Research Associates not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  Software Research
 * Associates makes no representations about the suitability of this software
 * for any purpose.  It is provided "as is" without express or implied
 * warranty.
 */

#include "twinint.h"

void FAR PASCAL
XDefineCursor(Display FAR * dummy, HWND hwnd, HCURSOR hcs)
{
    POINT pt;
    XSetWindowAttributes attrs;
    BYTE result;

    attrs.cursor = hcs;
    result = _SetWindowAttributes(hwnd, CWCursor, &attrs);
    if (result != Success) {
	PostError(result, hwnd);
	return;
    }
    GetCursorPos(&pt);
    SetCursorPos(pt.x, pt.y);
}

void  FAR PASCAL
XUndefineCursor(Display FAR * dummy, HWND hwnd)
{
    POINT pt;
    XSetWindowAttributes attrs;
    BYTE result;

    attrs.cursor = GetWindowWord(hwnd, HPCS_OFFSET); 
    result = _SetWindowAttributes(hwnd, CWCursor, &attrs);
    if (result != Success) {
	PostError(result, hwnd);
	return;
    }
    SetWindowWord(hwnd, HPCS_OFFSET, NULL);
    GetCursorPos(&pt);
    SetCursorPos(pt.x, pt.y);
}

HCURSOR NEAR PASCAL
FindCursor(HWND hwnd)
{
    HCURSOR hcs;

    if (hwnd == HWND_DESKTOP) 
    	return hDefaultCursor;
     
    if ((hcs = GetWindowWord(hwnd, HACS_OFFSET)) != NULL)
	return hcs;

   return FindCursor(GetParent(hwnd));
}
