/*
 * xgrab.c --
 *
 * Copyright (c) 1994 Software Research Associates, Inc.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Software Research Associates not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  Software Research
 * Associates makes no representations about the suitability of this software
 * for any purpose.  It is provided "as is" without express or implied
 * warranty.
 */
 
#include <X11/Xlib.h>
#include "twinint.h"

int fAutoGrab = 0;
int fPtGrab = 0;
HWND hPtGrabWnd = None;
HTASK hPtGrabTask = None; 
int fKbGrab = 0;
HWND hKbGrabWnd = None;
HTASK hKbGrabTask = None;

int FAR PASCAL 
XGrabPointer(lpDisp, hGrab, owner_event, event_mask, pointer_mode,
keybord_mode, hConfine, hCursor, time)
Display FAR * lpDisp;
HWND hGrab;
Bool owner_event;	 
unsigned long event_mask;
int pointer_mode, keybord_mode;	 
HWND hConfine;
HCURSOR hCursor;	
Time time;
{
    HTASK htask = GetCurrentTask();

    if (fPtGrab == ON) {
    	if (hPtGrabTask != htask)
	    return AlreadyGrabbed;
    } else {
	if (fAutoGrab == ON) {
	    ReleaseCapture();
	    fAutoGrab = OFF;					 
	}
	hPtGrabTask = htask;
	fPtGrab = ON;
    }	
    hPtGrabWnd = hGrab;
    return Success;
}

void FAR PASCAL
XUngrabPointer(lpDisp, time)
Display FAR * lpDisp;
Time time;
{
    if (fAutoGrab == ON) {
	ReleaseCapture();
	fAutoGrab = OFF;					 
    }
    fPtGrab = OFF;
}


int FAR PASCAL
XGrabKeyboard(lpDisp, hGrab, owner_events,
pointer_mode, keyboard_mode, time)
Display FAR * lpDisp;
HWND hGrab;
Bool owner_events;
int pointer_mode, keyboard_mode;
Time time;
{
    HTASK htask = GetCurrentTask();

    if (fKbGrab == ON) {
    	if (hKbGrabTask != htask)
	    return AlreadyGrabbed;
    } else {
	hKbGrabTask = htask;
	fKbGrab = ON;
    }	
    hKbGrabWnd = hGrab;
    return Success;
}

void FAR PASCAL
XUngrabKeyboard(lpDisp, time)
Display FAR * lpDisp;
Time time;
{
    fKbGrab = OFF;
}	
